#ifndef _STT_READ_H
#define _STT_READ_H

#include "types.h"

enum {
	RS_NORM,
	RS_COMMENT,
	RS_COMMENT_BODY,
	RS_COMMENT_1,
	RS_COMMENT_FILE,
	RS_STRING,
	RS_STRING_ESCAPE,
	RS_INTEGER,
	RS_NUM,
	RS_MINUS,
	RS_SYMBOL,
	RS_DOT,
	RS_COLON,
	RS_COMMA,
	RS_STRING_ESCAPE_HEX,
	RS_STRING_ESCAPE_HEX_2,
	RS_HASH,
	RS_CHAR_CONST
};

/* parser state */
typedef struct {
	int state;
	int line, col;
	s_obj *out;
	s_obj *stack;
	s_obj *act;

	char *token;
	int buflen, strlen;
	int ahead;

	char ch;
} read_state;

/* create read_state */
read_state *create_read_state();

/* destroy read_state */
void free_read_state(read_state *s);

/* reset parser */
void read_reset(read_state *s);

/* read a character */
s_obj *read_ch(read_state *s, int ch);

/* initialize a readtable */
void readtable_init(s_obj *rd);

/* read an object from a stream */
s_obj *readstream(varctx *ctx, s_obj *str);

#endif
